<!doctype html>
<html>

<head>
    <meta charset="utf-8">
    <title>Documento sin título</title>
    <script type="text/javascript">
        this.g = {};
        g.x = 0;
        g.y = 0;
        g.moon = new Image();
        g.moon.src = 'https://mdn.mozillademos.org/files/1429/Canvas_earth.png';

        function dibujarCanvas() {
            g.canvas = document.getElementById('miCanvas');
            g.contexto = g.canvas.getContext('2d');
            g.paso = 1;
            setInterval(acelerar, 1000);
            f1();
            window.addEventListener("keydown", f2);
        }

        function acelerar() {
            g.paso += 1;
        }

        function f2() {
            //console.log(event.which);
            switch (event.which) {
                case 38:
                    g.direccion = "arriba";
                    break;
                case 40:
                    g.direccion = "abajo";
                    break;
                case 37:
                    g.direccion = "izquierda";
                    break;
                case 39:
                    g.direccion = "derecha";
                    break;
            }
        }

        function f1() {
            if (g.y + 30 > g.canvas.height || g.y < 0 || g.x + 30 > g.canvas.width || g.x + 30 < 0) {
                window.cancelAnimationFrame(f1);
            } else {
                setTimeout(function() {
                    window.requestAnimationFrame(f1)
                }, 50);

            }

            switch (g.direccion) {
                case "arriba":
                    g.y -= g.paso;
                    break;
                case "abajo":
                    g.y += g.paso;
                    break;
                case "izquierda":
                    g.x -= g.paso;
                    break;
                case "derecha":
                    g.x += g.paso;
                    break;
                default:
                    break;
            }
            //g.contexto.clearRect(0,0,450,350); 
            g.contexto.fillStyle = 'rgba(200, 200, 200, 0.1)';
            g.contexto.fillRect(0, 0, g.canvas.width, g.canvas.height);
            g.contexto.drawImage(g.moon, g.x, g.y);
            //g.contexto.restore();
        }

        window.addEventListener("load", dibujarCanvas);
    </script>
</head>

<body>
    </head>

    <body>
        <canvas id="miCanvas" width="450" height="350" style="background:#000;margin:100px auto;display:block">Su navegador no soporta Canvas.</canvas>
    </body>

</html>
</body>

</html>